leetcode--1. 两数之和

leetcode--1. 两数之和_第1张图片
暴力求解:

public class t1 {
    public int[] twoSum(int[] nums, int target) {
        int flag1 = 0, flag2 ;
       for ( ;flag1 < nums.length-1; flag1 ++){
           for (flag2=flag1+1;flag2 <  nums.length; flag2 ++){
               if (nums[flag1] + nums[flag2] == target){
                   return new int[]{flag1,flag2};
               }
           }
       }
        throw  new IllegalArgumentException("No two sum solution");
    }
    }
}

leetcode--1. 两数之和_第2张图片
方法2:哈希表(答案借鉴)

leetcode--1. 两数之和_第3张图片

  Map map = new HashMap<>();
        for (int i = 0; i < nums.length; i ++){
            map.put(nums[i],i);
        }
        for(int i = 0; i < nums.length; i ++){
            int component = target - nums[i];
            if(map.containsKey(component) && map.get(component) != i){
                return new int[] {map.get(component),i};
            }
        }
        throw new IllegalArgumentException("No two sum solution");
    }
}

这个思路就是:
以nums数组的元素作为map的key值,当然用下标作为key的话效率不高,有点类似数组来操作了。通过遍历nums数组可以来获取组成target的另一个值(如果存在的话),方案就也是判断是否存在,这样就只用一个for循环了(降低了时间复杂度)。注意不能是同一个元素的判断条件。
leetcode--1. 两数之和_第4张图片
改进:遍历一次即可

  public int[] twoSum(int[] nums, int target) {
        Map map = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            int complement = target - nums[i];
            if (map.containsKey(complement)) {
                return new int[] { map.get(complement), i };
            }
            map.put(nums[i], i);
        }
        throw new IllegalArgumentException("No two sum solution");
    }

一边插入一边来检测,当满足条件的时候就终止
每次先判断下当前元素nums[i]的对应component是否存在改数组当中,因为现在是把数组转存到map中每次检查都是针对之前的检测过的元素,所以是不存在重复的情况的。先查再放。

你可能感兴趣的:(leetcode,菜鸟之路)